Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/proc/thread.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -60,7 +60,6 @@
 #include <arch/interrupt.h>
 #include <smp/ipi.h>
-#include <arch/faddr.h>
 #include <atomic.h>
-#include <mem.h>
+#include <memw.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -69,4 +68,5 @@
 #include <errno.h>
 #include <debug.h>
+#include <halt.h>
 
 /** Thread states */
@@ -94,4 +94,7 @@
  *
  * Members are of type thread_t.
+ *
+ * This structure contains weak references. Any reference from it must not leave
+ * threads_lock critical section unless strengthened via thread_try_ref().
  */
 odict_t threads;
@@ -102,52 +105,7 @@
 static slab_cache_t *thread_cache;
 
-#ifdef CONFIG_FPU
-slab_cache_t *fpu_context_cache;
-#endif
-
 static void *threads_getkey(odlink_t *);
 static int threads_cmp(void *, void *);
 
-/** Thread wrapper.
- *
- * This wrapper is provided to ensure that every thread makes a call to
- * thread_exit() when its implementing function returns.
- *
- * interrupts_disable() is assumed.
- *
- */
-static void cushion(void)
-{
-	void (*f)(void *) = THREAD->thread_code;
-	void *arg = THREAD->thread_arg;
-	THREAD->last_cycle = get_cycle();
-
-	/* This is where each thread wakes up after its creation */
-	irq_spinlock_unlock(&THREAD->lock, false);
-	interrupts_enable();
-
-	f(arg);
-
-	/* Accumulate accounting to the task */
-	irq_spinlock_lock(&THREAD->lock, true);
-	if (!THREAD->uncounted) {
-		thread_update_accounting(true);
-		uint64_t ucycles = THREAD->ucycles;
-		THREAD->ucycles = 0;
-		uint64_t kcycles = THREAD->kcycles;
-		THREAD->kcycles = 0;
-
-		irq_spinlock_pass(&THREAD->lock, &TASK->lock);
-		TASK->ucycles += ucycles;
-		TASK->kcycles += kcycles;
-		irq_spinlock_unlock(&TASK->lock, true);
-	} else
-		irq_spinlock_unlock(&THREAD->lock, true);
-
-	thread_exit();
-
-	/* Not reached */
-}
-
 /** Initialization and allocation for thread_t structure
  *
@@ -157,5 +115,4 @@
 	thread_t *thread = (thread_t *) obj;
 
-	irq_spinlock_initialize(&thread->lock, "thread_t_lock");
 	link_initialize(&thread->rq_link);
 	link_initialize(&thread->wq_link);
@@ -164,11 +121,4 @@
 	/* call the architecture-specific part of the constructor */
 	thr_constructor_arch(thread);
-
-#ifdef CONFIG_FPU
-	thread->saved_fpu_context = slab_alloc(fpu_context_cache,
-	    FRAME_ATOMIC | kmflags);
-	if (!thread->saved_fpu_context)
-		return ENOMEM;
-#endif /* CONFIG_FPU */
 
 	/*
@@ -198,11 +148,6 @@
 	uintptr_t stack_phys =
 	    frame_alloc(STACK_FRAMES, kmflags, STACK_SIZE - 1);
-	if (!stack_phys) {
-#ifdef CONFIG_FPU
-		assert(thread->saved_fpu_context);
-		slab_free(fpu_context_cache, thread->saved_fpu_context);
-#endif
+	if (!stack_phys)
 		return ENOMEM;
-	}
 
 	thread->kstack = (uint8_t *) PA2KA(stack_phys);
@@ -225,9 +170,4 @@
 	frame_free(KA2PA(thread->kstack), STACK_FRAMES);
 
-#ifdef CONFIG_FPU
-	assert(thread->saved_fpu_context);
-	slab_free(fpu_context_cache, thread->saved_fpu_context);
-#endif
-
 	return STACK_FRAMES;  /* number of frames freed */
 }
@@ -243,12 +183,7 @@
 
 	atomic_store(&nrdy, 0);
-	thread_cache = slab_cache_create("thread_t", sizeof(thread_t), 0,
+	thread_cache = slab_cache_create("thread_t", sizeof(thread_t), _Alignof(thread_t),
 	    thr_constructor, thr_destructor, 0);
 
-#ifdef CONFIG_FPU
-	fpu_context_cache = slab_cache_create("fpu_context_t",
-	    sizeof(fpu_context_t), FPU_CONTEXT_ALIGN, NULL, NULL, 0);
-#endif
-
 	odict_initialize(&threads, threads_getkey, threads_cmp);
 }
@@ -261,65 +196,18 @@
 void thread_wire(thread_t *thread, cpu_t *cpu)
 {
-	irq_spinlock_lock(&thread->lock, true);
-	thread->cpu = cpu;
-	thread->wired = true;
-	irq_spinlock_unlock(&thread->lock, true);
-}
-
-/** Invoked right before thread_ready() readies the thread. thread is locked. */
-static void before_thread_is_ready(thread_t *thread)
-{
-	assert(irq_spinlock_locked(&thread->lock));
-}
-
-/** Make thread ready
- *
- * Switch thread to the ready state.
- *
- * @param thread Thread to make ready.
- *
- */
-void thread_ready(thread_t *thread)
-{
-	irq_spinlock_lock(&thread->lock, true);
-
-	assert(thread->state != Ready);
-
-	before_thread_is_ready(thread);
-
-	int i = (thread->priority < RQ_COUNT - 1) ?
-	    ++thread->priority : thread->priority;
-
-	cpu_t *cpu;
-	if (thread->wired || thread->nomigrate || thread->fpu_context_engaged) {
-		/* Cannot ready to another CPU */
-		assert(thread->cpu != NULL);
-		cpu = thread->cpu;
-	} else if (thread->stolen) {
-		/* Ready to the stealing CPU */
-		cpu = CPU;
-	} else if (thread->cpu) {
-		/* Prefer the CPU on which the thread ran last */
-		assert(thread->cpu != NULL);
-		cpu = thread->cpu;
-	} else {
-		cpu = CPU;
-	}
-
-	thread->state = Ready;
-
-	irq_spinlock_pass(&thread->lock, &(cpu->rq[i].lock));
-
-	/*
-	 * Append thread to respective ready queue
-	 * on respective processor.
-	 */
-
-	list_append(&thread->rq_link, &cpu->rq[i].rq);
-	cpu->rq[i].n++;
-	irq_spinlock_unlock(&(cpu->rq[i].lock), true);
-
-	atomic_inc(&nrdy);
-	atomic_inc(&cpu->nrdy);
+	ipl_t ipl = interrupts_disable();
+	atomic_set_unordered(&thread->cpu, cpu);
+	thread->nomigrate++;
+	interrupts_restore(ipl);
+}
+
+/** Start a thread that wasn't started yet since it was created.
+ *
+ * @param thread A reference to the newly created thread.
+ */
+void thread_start(thread_t *thread)
+{
+	assert(atomic_get_unordered(&thread->state) == Entering);
+	thread_requeue_sleeping(thread_ref(thread));
 }
 
@@ -346,4 +234,6 @@
 		return NULL;
 
+	refcount_init(&thread->refcount);
+
 	if (thread_create_arch(thread, flags) != EOK) {
 		slab_free(thread_cache, thread);
@@ -358,13 +248,8 @@
 	irq_spinlock_unlock(&tidlock, true);
 
-	memset(&thread->saved_context, 0, sizeof(thread->saved_context));
-	context_set(&thread->saved_context, FADDR(cushion),
-	    (uintptr_t) thread->kstack, STACK_SIZE);
+	context_create(&thread->saved_context, thread_main_func,
+	    thread->kstack, STACK_SIZE);
 
 	current_initialize((current_t *) thread->kstack);
-
-	ipl_t ipl = interrupts_disable();
-	thread->saved_context.ipl = interrupts_read();
-	interrupts_restore(ipl);
 
 	str_cpy(thread->name, THREAD_NAME_BUFLEN, name);
@@ -372,12 +257,10 @@
 	thread->thread_code = func;
 	thread->thread_arg = arg;
-	thread->ticks = -1;
-	thread->ucycles = 0;
-	thread->kcycles = 0;
+	thread->ucycles = ATOMIC_TIME_INITIALIZER();
+	thread->kcycles = ATOMIC_TIME_INITIALIZER();
 	thread->uncounted =
 	    ((flags & THREAD_FLAG_UNCOUNTED) == THREAD_FLAG_UNCOUNTED);
-	thread->priority = -1;          /* Start in rq[0] */
-	thread->cpu = NULL;
-	thread->wired = false;
+	atomic_init(&thread->priority, 0);
+	atomic_init(&thread->cpu, NULL);
 	thread->stolen = false;
 	thread->uspace =
@@ -385,11 +268,7 @@
 
 	thread->nomigrate = 0;
-	thread->state = Entering;
-
-	timeout_initialize(&thread->sleep_timeout);
-	thread->sleep_interruptible = false;
-	thread->sleep_composable = false;
-	thread->sleep_queue = NULL;
-	thread->timeout_pending = false;
+	atomic_init(&thread->state, Entering);
+
+	atomic_init(&thread->sleep_queue, NULL);
 
 	thread->in_copy_from_uspace = false;
@@ -397,5 +276,6 @@
 
 	thread->interrupted = false;
-	thread->detached = false;
+	atomic_init(&thread->sleep_state, SLEEP_INITIAL);
+
 	waitq_initialize(&thread->join_wq);
 
@@ -403,5 +283,4 @@
 
 	thread->fpu_context_exists = false;
-	thread->fpu_context_engaged = false;
 
 	odlink_initialize(&thread->lthreads);
@@ -409,5 +288,5 @@
 #ifdef CONFIG_UDEBUG
 	/* Initialize debugging stuff */
-	thread->btrace = false;
+	atomic_init(&thread->btrace, false);
 	udebug_thread_initialize(&thread->udebug);
 #endif
@@ -423,32 +302,61 @@
  * Detach thread from all queues, cpus etc. and destroy it.
  *
- * @param thread  Thread to be destroyed.
- * @param irq_res Indicate whether it should unlock thread->lock
- *                in interrupts-restore mode.
- *
- */
-void thread_destroy(thread_t *thread, bool irq_res)
-{
-	assert(irq_spinlock_locked(&thread->lock));
-	assert((thread->state == Exiting) || (thread->state == Lingering));
+ * @param obj  Thread to be destroyed.
+ *
+ */
+static void thread_destroy(void *obj)
+{
+	thread_t *thread = (thread_t *) obj;
+
+	assert_link_not_used(&thread->rq_link);
+	assert_link_not_used(&thread->wq_link);
+
 	assert(thread->task);
-	assert(thread->cpu);
-
-	irq_spinlock_lock(&thread->cpu->lock, false);
-	if (thread->cpu->fpu_owner == thread)
-		thread->cpu->fpu_owner = NULL;
-	irq_spinlock_unlock(&thread->cpu->lock, false);
-
-	irq_spinlock_pass(&thread->lock, &threads_lock);
-
+
+	ipl_t ipl = interrupts_disable();
+
+	/* Remove thread from global list. */
+	irq_spinlock_lock(&threads_lock, false);
 	odict_remove(&thread->lthreads);
-
-	irq_spinlock_pass(&threads_lock, &thread->task->lock);
+	irq_spinlock_unlock(&threads_lock, false);
+
+	/* Remove thread from task's list and accumulate accounting. */
+	irq_spinlock_lock(&thread->task->lock, false);
+
+	list_remove(&thread->th_link);
 
 	/*
-	 * Detach from the containing task.
+	 * No other CPU has access to this thread anymore, so we don't need
+	 * thread->lock for accessing thread's fields after this point.
 	 */
-	list_remove(&thread->th_link);
-	irq_spinlock_unlock(&thread->task->lock, irq_res);
+
+	if (!thread->uncounted) {
+		thread->task->ucycles += atomic_time_read(&thread->ucycles);
+		thread->task->kcycles += atomic_time_read(&thread->kcycles);
+	}
+
+	irq_spinlock_unlock(&thread->task->lock, false);
+
+	assert((atomic_get_unordered(&thread->state) == Exiting) || (atomic_get_unordered(&thread->state) == Lingering));
+
+	/* Clear cpu->fpu_owner if set to this thread. */
+#ifdef CONFIG_FPU_LAZY
+	cpu_t *cpu = atomic_get_unordered(&thread->cpu);
+	if (cpu) {
+		/*
+		 * We need to lock for this because the old CPU can concurrently try
+		 * to dump this thread's FPU state, in which case we need to wait for
+		 * it to finish. An atomic compare-and-swap wouldn't be enough.
+		 */
+		irq_spinlock_lock(&cpu->fpu_lock, false);
+
+		if (atomic_get_unordered(&cpu->fpu_owner) == thread)
+			atomic_set_unordered(&cpu->fpu_owner, NULL);
+
+		irq_spinlock_unlock(&cpu->fpu_lock, false);
+	}
+#endif
+
+	interrupts_restore(ipl);
 
 	/*
@@ -456,5 +364,14 @@
 	 */
 	task_release(thread->task);
+	thread->task = NULL;
+
 	slab_free(thread_cache, thread);
+}
+
+void thread_put(thread_t *thread)
+{
+	if (refcount_down(&thread->refcount)) {
+		thread_destroy(thread);
+	}
 }
 
@@ -470,8 +387,10 @@
 void thread_attach(thread_t *thread, task_t *task)
 {
+	ipl_t ipl = interrupts_disable();
+
 	/*
 	 * Attach to the specified task.
 	 */
-	irq_spinlock_lock(&task->lock, true);
+	irq_spinlock_lock(&task->lock, false);
 
 	/* Hold a reference to the task. */
@@ -484,11 +403,14 @@
 	list_append(&thread->th_link, &task->threads);
 
-	irq_spinlock_pass(&task->lock, &threads_lock);
+	irq_spinlock_unlock(&task->lock, false);
 
 	/*
 	 * Register this thread in the system-wide dictionary.
 	 */
+	irq_spinlock_lock(&threads_lock, false);
 	odict_insert(&thread->lthreads, &threads, NULL);
-	irq_spinlock_unlock(&threads_lock, true);
+	irq_spinlock_unlock(&threads_lock, false);
+
+	interrupts_restore(ipl);
 }
 
@@ -527,20 +449,6 @@
 	}
 
-restart:
-	irq_spinlock_lock(&THREAD->lock, true);
-	if (THREAD->timeout_pending) {
-		/* Busy waiting for timeouts in progress */
-		irq_spinlock_unlock(&THREAD->lock, true);
-		goto restart;
-	}
-
-	THREAD->state = Exiting;
-	irq_spinlock_unlock(&THREAD->lock, true);
-
-	scheduler();
-
-	/* Not reached */
-	while (true)
-		;
+	scheduler_enter(Exiting);
+	unreachable();
 }
 
@@ -551,44 +459,118 @@
  * blocking call was interruptable. See waitq_sleep_timeout().
  *
- * The caller must guarantee the thread object is valid during the entire
- * function, eg by holding the threads_lock lock.
- *
  * Interrupted threads automatically exit when returning back to user space.
  *
- * @param thread A valid thread object. The caller must guarantee it
- *               will remain valid until thread_interrupt() exits.
+ * @param thread A valid thread object.
  */
 void thread_interrupt(thread_t *thread)
 {
 	assert(thread != NULL);
-
-	irq_spinlock_lock(&thread->lock, true);
-
 	thread->interrupted = true;
-	bool sleeping = (thread->state == Sleeping);
-
-	irq_spinlock_unlock(&thread->lock, true);
-
-	if (sleeping)
-		waitq_interrupt_sleep(thread);
-}
-
-/** Returns true if the thread was interrupted.
- *
- * @param thread A valid thread object. User must guarantee it will
- *               be alive during the entire call.
- * @return true if the thread was already interrupted via thread_interrupt().
- */
-bool thread_interrupted(thread_t *thread)
+	thread_wakeup(thread);
+}
+
+/** Prepare for putting the thread to sleep.
+ *
+ * @returns whether the thread is currently terminating. If THREAD_OK
+ * is returned, the thread is guaranteed to be woken up instantly if the thread
+ * is terminated at any time between this function's return and
+ * thread_wait_finish(). If THREAD_TERMINATING is returned, the thread can still
+ * go to sleep, but doing so will delay termination.
+ */
+thread_termination_state_t thread_wait_start(void)
+{
+	assert(THREAD != NULL);
+
+	/*
+	 * This is an exchange rather than a store so that we can use the acquire
+	 * semantics, which is needed to ensure that code after this operation sees
+	 * memory ops made before thread_wakeup() in other thread, if that wakeup
+	 * was reset by this operation.
+	 *
+	 * In particular, we need this to ensure we can't miss the thread being
+	 * terminated concurrently with a synchronization primitive preparing to
+	 * sleep.
+	 */
+	(void) atomic_exchange_explicit(&THREAD->sleep_state, SLEEP_INITIAL,
+	    memory_order_acquire);
+
+	return THREAD->interrupted ? THREAD_TERMINATING : THREAD_OK;
+}
+
+static void thread_wait_timeout_callback(void *arg)
+{
+	thread_wakeup(arg);
+}
+
+/**
+ * Suspends this thread's execution until thread_wakeup() is called on it,
+ * or deadline is reached.
+ *
+ * The way this would normally be used is that the current thread call
+ * thread_wait_start(), and if interruption has not been signaled, stores
+ * a reference to itself in a synchronized structure (such as waitq).
+ * After that, it releases any spinlocks it might hold and calls this function.
+ *
+ * The thread doing the wakeup will acquire the thread's reference from said
+ * synchronized structure and calls thread_wakeup() on it.
+ *
+ * Notably, there can be more than one thread performing wakeup.
+ * The number of performed calls to thread_wakeup(), or their relative
+ * ordering with thread_wait_finish(), does not matter. However, calls to
+ * thread_wakeup() are expected to be synchronized with thread_wait_start()
+ * with which they are associated, otherwise wakeups may be missed.
+ * However, the operation of thread_wakeup() is defined at any time,
+ * synchronization notwithstanding (in the sense of C un/defined behavior),
+ * and is in fact used to interrupt waiting threads by external events.
+ * The waiting thread must operate correctly in face of spurious wakeups,
+ * and clean up its reference in the synchronization structure if necessary.
+ *
+ * Returns THREAD_WAIT_TIMEOUT if timeout fired, which is a necessary condition
+ * for it to have been waken up by the timeout, but the caller must assume
+ * that proper wakeups, timeouts and interrupts may occur concurrently, so
+ * the fact timeout has been registered does not necessarily mean the thread
+ * has not been woken up or interrupted.
+ */
+thread_wait_result_t thread_wait_finish(deadline_t deadline)
+{
+	assert(THREAD != NULL);
+
+	timeout_t timeout;
+
+	/* Extra check to avoid going to scheduler if we don't need to. */
+	if (atomic_load_explicit(&THREAD->sleep_state, memory_order_acquire) !=
+	    SLEEP_INITIAL)
+		return THREAD_WAIT_SUCCESS;
+
+	if (deadline != DEADLINE_NEVER) {
+		timeout_initialize(&timeout);
+		timeout_register_deadline(&timeout, deadline,
+		    thread_wait_timeout_callback, THREAD);
+	}
+
+	scheduler_enter(Sleeping);
+
+	if (deadline != DEADLINE_NEVER && !timeout_unregister(&timeout)) {
+		return THREAD_WAIT_TIMEOUT;
+	} else {
+		return THREAD_WAIT_SUCCESS;
+	}
+}
+
+void thread_wakeup(thread_t *thread)
 {
 	assert(thread != NULL);
 
-	bool interrupted;
-
-	irq_spinlock_lock(&thread->lock, true);
-	interrupted = thread->interrupted;
-	irq_spinlock_unlock(&thread->lock, true);
-
-	return interrupted;
+	int state = atomic_exchange_explicit(&thread->sleep_state, SLEEP_WOKE,
+	    memory_order_acq_rel);
+
+	if (state == SLEEP_ASLEEP) {
+		/*
+		 * Only one thread gets to do this.
+		 * The reference consumed here is the reference implicitly passed to
+		 * the waking thread by the sleeper in thread_wait_finish().
+		 */
+		thread_requeue_sleeping(thread);
+	}
 }
 
@@ -596,7 +578,10 @@
 void thread_migration_disable(void)
 {
+	ipl_t ipl = interrupts_disable();
+
 	assert(THREAD);
-
 	THREAD->nomigrate++;
+
+	interrupts_restore(ipl);
 }
 
@@ -604,4 +589,6 @@
 void thread_migration_enable(void)
 {
+	ipl_t ipl = interrupts_disable();
+
 	assert(THREAD);
 	assert(THREAD->nomigrate > 0);
@@ -609,4 +596,6 @@
 	if (THREAD->nomigrate > 0)
 		THREAD->nomigrate--;
+
+	interrupts_restore(ipl);
 }
 
@@ -632,5 +621,11 @@
 }
 
+errno_t thread_join(thread_t *thread)
+{
+	return thread_join_timeout(thread, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE);
+}
+
 /** Wait for another thread to exit.
+ * After successful wait, the thread reference is destroyed.
  *
  * @param thread Thread to join on exit.
@@ -643,52 +638,20 @@
 errno_t thread_join_timeout(thread_t *thread, uint32_t usec, unsigned int flags)
 {
+	assert(thread != NULL);
+
 	if (thread == THREAD)
 		return EINVAL;
 
-	/*
-	 * Since thread join can only be called once on an undetached thread,
-	 * the thread pointer is guaranteed to be still valid.
-	 */
-
-	irq_spinlock_lock(&thread->lock, true);
-	assert(!thread->detached);
-	irq_spinlock_unlock(&thread->lock, true);
-
-	return waitq_sleep_timeout(&thread->join_wq, usec, flags, NULL);
-
-	// FIXME: join should deallocate the thread.
-	//        Current code calls detach after join, that's contrary to how
-	//        join is used in other threading APIs.
-}
-
-/** Detach thread.
- *
- * Mark the thread as detached. If the thread is already
- * in the Lingering state, deallocate its resources.
- *
- * @param thread Thread to be detached.
- *
- */
+	errno_t rc = _waitq_sleep_timeout(&thread->join_wq, usec, flags);
+
+	if (rc == EOK)
+		thread_put(thread);
+
+	return rc;
+}
+
 void thread_detach(thread_t *thread)
 {
-	/*
-	 * Since the thread is expected not to be already detached,
-	 * pointer to it must be still valid.
-	 */
-	irq_spinlock_lock(&thread->lock, true);
-	assert(!thread->detached);
-
-	if (thread->state == Lingering) {
-		/*
-		 * Unlock &thread->lock and restore
-		 * interrupts in thread_destroy().
-		 */
-		thread_destroy(thread, true);
-		return;
-	} else {
-		thread->detached = true;
-	}
-
-	irq_spinlock_unlock(&thread->lock, true);
+	thread_put(thread);
 }
 
@@ -706,5 +669,12 @@
 	waitq_initialize(&wq);
 
-	(void) waitq_sleep_timeout(&wq, usec, SYNCH_FLAGS_NON_BLOCKING, NULL);
+	(void) waitq_sleep_timeout(&wq, usec);
+}
+
+/** Allow other threads to run. */
+void thread_yield(void)
+{
+	assert(THREAD != NULL);
+	scheduler_enter(Running);
 }
 
@@ -713,6 +683,8 @@
 	uint64_t ucycles, kcycles;
 	char usuffix, ksuffix;
-	order_suffix(thread->ucycles, &ucycles, &usuffix);
-	order_suffix(thread->kcycles, &kcycles, &ksuffix);
+	order_suffix(atomic_time_read(&thread->ucycles), &ucycles, &usuffix);
+	order_suffix(atomic_time_read(&thread->kcycles), &kcycles, &ksuffix);
+
+	state_t state = atomic_get_unordered(&thread->state);
 
 	char *name;
@@ -722,41 +694,22 @@
 		name = thread->name;
 
-#ifdef __32_BITS__
 	if (additional)
-		printf("%-8" PRIu64 " %10p %10p %9" PRIu64 "%c %9" PRIu64 "%c ",
+		printf("%-8" PRIu64 " %p %p %9" PRIu64 "%c %9" PRIu64 "%c ",
 		    thread->tid, thread->thread_code, thread->kstack,
 		    ucycles, usuffix, kcycles, ksuffix);
 	else
-		printf("%-8" PRIu64 " %-14s %10p %-8s %10p %-5" PRIu32 "\n",
-		    thread->tid, name, thread, thread_states[thread->state],
+		printf("%-8" PRIu64 " %-14s %p %-8s %p %-5" PRIu32 "\n",
+		    thread->tid, name, thread, thread_states[state],
 		    thread->task, thread->task->container);
-#endif
-
-#ifdef __64_BITS__
-	if (additional)
-		printf("%-8" PRIu64 " %18p %18p\n"
-		    "         %9" PRIu64 "%c %9" PRIu64 "%c ",
-		    thread->tid, thread->thread_code, thread->kstack,
-		    ucycles, usuffix, kcycles, ksuffix);
-	else
-		printf("%-8" PRIu64 " %-14s %18p %-8s %18p %-5" PRIu32 "\n",
-		    thread->tid, name, thread, thread_states[thread->state],
-		    thread->task, thread->task->container);
-#endif
 
 	if (additional) {
-		if (thread->cpu)
-			printf("%-5u", thread->cpu->id);
+		cpu_t *cpu = atomic_get_unordered(&thread->cpu);
+		if (cpu)
+			printf("%-5u", cpu->id);
 		else
 			printf("none ");
 
-		if (thread->state == Sleeping) {
-#ifdef __32_BITS__
-			printf(" %10p", thread->sleep_queue);
-#endif
-
-#ifdef __64_BITS__
-			printf(" %18p", thread->sleep_queue);
-#endif
+		if (state == Sleeping) {
+			printf(" %p", thread->sleep_queue);
 		}
 
@@ -774,24 +727,22 @@
 	thread_t *thread;
 
-	/* Messing with thread structures, avoid deadlock */
+	/* Accessing system-wide threads list through thread_first()/thread_next(). */
 	irq_spinlock_lock(&threads_lock, true);
 
-#ifdef __32_BITS__
-	if (additional)
-		printf("[id    ] [code    ] [stack   ] [ucycles ] [kcycles ]"
-		    " [cpu] [waitqueue]\n");
-	else
-		printf("[id    ] [name        ] [address ] [state ] [task    ]"
-		    " [ctn]\n");
-#endif
-
-#ifdef __64_BITS__
-	if (additional) {
-		printf("[id    ] [code            ] [stack           ]\n"
-		    "         [ucycles ] [kcycles ] [cpu] [waitqueue       ]\n");
-	} else
-		printf("[id    ] [name        ] [address         ] [state ]"
-		    " [task            ] [ctn]\n");
-#endif
+	if (sizeof(void *) <= 4) {
+		if (additional)
+			printf("[id    ] [code    ] [stack   ] [ucycles ] [kcycles ]"
+			    " [cpu] [waitqueue]\n");
+		else
+			printf("[id    ] [name        ] [address ] [state ] [task    ]"
+			    " [ctn]\n");
+	} else {
+		if (additional) {
+			printf("[id    ] [code            ] [stack           ] [ucycles ] [kcycles ]"
+			    " [cpu] [waitqueue       ]\n");
+		} else
+			printf("[id    ] [name        ] [address         ] [state ]"
+			    " [task            ] [ctn]\n");
+	}
 
 	thread = thread_first();
@@ -804,23 +755,28 @@
 }
 
-/** Check whether thread exists.
- *
- * Note that threads_lock must be already held and
- * interrupts must be already disabled.
- *
- * @param thread Pointer to thread.
- *
- * @return True if thread t is known to the system, false otherwise.
- *
- */
-bool thread_exists(thread_t *thread)
-{
-	assert(interrupts_disabled());
-	assert(irq_spinlock_locked(&threads_lock));
-
+static bool thread_exists(thread_t *thread)
+{
 	odlink_t *odlink = odict_find_eq(&threads, thread, NULL);
 	return odlink != NULL;
 }
 
+/** Check whether the thread exists, and if so, return a reference to it.
+ */
+thread_t *thread_try_get(thread_t *thread)
+{
+	irq_spinlock_lock(&threads_lock, true);
+
+	if (thread_exists(thread)) {
+		/* Try to strengthen the reference. */
+		thread = thread_try_ref(thread);
+	} else {
+		thread = NULL;
+	}
+
+	irq_spinlock_unlock(&threads_lock, true);
+
+	return thread;
+}
+
 /** Update accounting of current thread.
  *
@@ -833,13 +789,12 @@
 void thread_update_accounting(bool user)
 {
+	assert(interrupts_disabled());
+
 	uint64_t time = get_cycle();
 
-	assert(interrupts_disabled());
-	assert(irq_spinlock_locked(&THREAD->lock));
-
 	if (user)
-		THREAD->ucycles += time - THREAD->last_cycle;
+		atomic_time_increment(&THREAD->ucycles, time - THREAD->last_cycle);
 	else
-		THREAD->kcycles += time - THREAD->last_cycle;
+		atomic_time_increment(&THREAD->kcycles, time - THREAD->last_cycle);
 
 	THREAD->last_cycle = time;
@@ -850,4 +805,8 @@
  * The threads_lock must be already held by the caller of this function and
  * interrupts must be disabled.
+ *
+ * The returned reference is weak.
+ * If the caller needs to keep it, thread_try_ref() must be used to upgrade
+ * to a strong reference _before_ threads_lock is released.
  *
  * @param id Thread ID.
@@ -928,13 +887,11 @@
 {
 	irq_spinlock_lock(&threads_lock, true);
-
-	thread_t *thread = thread_find_by_id(thread_id);
+	thread_t *thread = thread_try_ref(thread_find_by_id(thread_id));
+	irq_spinlock_unlock(&threads_lock, true);
+
 	if (thread == NULL) {
 		printf("No such thread.\n");
-		irq_spinlock_unlock(&threads_lock, true);
 		return;
 	}
-
-	irq_spinlock_lock(&thread->lock, false);
 
 	/*
@@ -950,20 +907,9 @@
 	 */
 
-	bool sleeping = false;
-	istate_t *istate = thread->udebug.uspace_state;
-	if (istate != NULL) {
-		printf("Scheduling thread stack trace.\n");
-		thread->btrace = true;
-		if (thread->state == Sleeping)
-			sleeping = true;
-	} else
-		printf("Thread interrupt state not available.\n");
-
-	irq_spinlock_unlock(&thread->lock, false);
-
-	if (sleeping)
-		waitq_interrupt_sleep(thread);
-
-	irq_spinlock_unlock(&threads_lock, true);
+	printf("Scheduling thread stack trace.\n");
+	atomic_set_unordered(&thread->btrace, true);
+
+	thread_wakeup(thread);
+	thread_put(thread);
 }
 
@@ -1065,5 +1011,6 @@
 		thread_attach(thread, TASK);
 #endif
-		thread_ready(thread);
+		thread_start(thread);
+		thread_put(thread);
 
 		return 0;
Index: kernel/generic/src/security/perm.c
===================================================================
--- kernel/generic/src/security/perm.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/security/perm.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -89,18 +89,19 @@
 		return EPERM;
 
-	irq_spinlock_lock(&tasks_lock, true);
 	task_t *task = task_find_by_id(taskid);
-
-	if ((!task) || (!container_check(CONTAINER, task->container))) {
-		irq_spinlock_unlock(&tasks_lock, true);
+	if (!task)
 		return ENOENT;
+
+	errno_t rc = ENOENT;
+
+	irq_spinlock_lock(&task->lock, true);
+	if (container_check(CONTAINER, task->container)) {
+		task->perms |= perms;
+		rc = EOK;
 	}
-
-	irq_spinlock_lock(&task->lock, false);
-	task->perms |= perms;
-	irq_spinlock_unlock(&task->lock, false);
-
-	irq_spinlock_unlock(&tasks_lock, true);
-	return EOK;
+	irq_spinlock_unlock(&task->lock, true);
+
+	task_release(task);
+	return rc;
 }
 
@@ -118,11 +119,7 @@
 static errno_t perm_revoke(task_id_t taskid, perm_t perms)
 {
-	irq_spinlock_lock(&tasks_lock, true);
-
 	task_t *task = task_find_by_id(taskid);
-	if ((!task) || (!container_check(CONTAINER, task->container))) {
-		irq_spinlock_unlock(&tasks_lock, true);
+	if (!task)
 		return ENOENT;
-	}
 
 	/*
@@ -131,17 +128,20 @@
 	 * doesn't have PERM_PERM.
 	 */
-	irq_spinlock_lock(&TASK->lock, false);
-
-	if ((!(TASK->perms & PERM_PERM)) || (task != TASK)) {
-		irq_spinlock_unlock(&TASK->lock, false);
-		irq_spinlock_unlock(&tasks_lock, true);
+	if (task != TASK && !(perm_get(TASK) & PERM_PERM)) {
+		task_release(task);
 		return EPERM;
 	}
 
-	task->perms &= ~perms;
-	irq_spinlock_unlock(&TASK->lock, false);
-
-	irq_spinlock_unlock(&tasks_lock, true);
-	return EOK;
+	errno_t rc = ENOENT;
+
+	irq_spinlock_lock(&task->lock, true);
+	if (container_check(CONTAINER, task->container)) {
+		task->perms &= ~perms;
+		rc = EOK;
+	}
+	irq_spinlock_unlock(&task->lock, true);
+
+	task_release(task);
+	return rc;
 }
 
Index: kernel/generic/src/smp/smp.c
===================================================================
--- kernel/generic/src/smp/smp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/smp/smp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,5 +39,5 @@
 #ifdef CONFIG_SMP
 
-waitq_t ap_completion_wq;
+semaphore_t ap_completion_semaphore;
 
 #endif /* CONFIG_SMP */
Index: kernel/generic/src/synch/condvar.c
===================================================================
--- kernel/generic/src/synch/condvar.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/synch/condvar.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -58,5 +58,5 @@
 void condvar_signal(condvar_t *cv)
 {
-	waitq_wakeup(&cv->wq, WAKEUP_FIRST);
+	waitq_signal(&cv->wq);
 }
 
@@ -68,5 +68,5 @@
 void condvar_broadcast(condvar_t *cv)
 {
-	waitq_wakeup(&cv->wq, WAKEUP_ALL);
+	waitq_wake_all(&cv->wq);
 }
 
@@ -76,31 +76,30 @@
  * @param mtx		Mutex.
  * @param usec		Timeout value in microseconds.
- * @param flags		Select mode of operation.
- *
- * For exact description of meaning of possible combinations of usec and flags,
- * see comment for waitq_sleep_timeout().  Note that when
- * SYNCH_FLAGS_NON_BLOCKING is specified here, EAGAIN is always
- * returned.
  *
  * @return		See comment for waitq_sleep_timeout().
  */
-errno_t _condvar_wait_timeout(condvar_t *cv, mutex_t *mtx, uint32_t usec, int flags)
+errno_t condvar_wait_timeout(condvar_t *cv, mutex_t *mtx, uint32_t usec)
 {
-	errno_t rc;
-	ipl_t ipl;
-	bool blocked;
+	wait_guard_t guard = waitq_sleep_prepare(&cv->wq);
 
-	ipl = waitq_sleep_prepare(&cv->wq);
 	/* Unlock only after the waitq is locked so we don't miss a wakeup. */
 	mutex_unlock(mtx);
 
-	cv->wq.missed_wakeups = 0;	/* Enforce blocking. */
-	rc = waitq_sleep_timeout_unsafe(&cv->wq, usec, flags, &blocked);
-	assert(blocked || rc != EOK);
+	errno_t rc = waitq_sleep_timeout_unsafe(&cv->wq, usec, SYNCH_FLAGS_NON_BLOCKING, guard);
 
-	waitq_sleep_finish(&cv->wq, blocked, ipl);
-	/* Lock only after releasing the waitq to avoid a possible deadlock. */
 	mutex_lock(mtx);
+	return rc;
+}
 
+errno_t condvar_wait(condvar_t *cv, mutex_t *mtx)
+{
+	wait_guard_t guard = waitq_sleep_prepare(&cv->wq);
+
+	/* Unlock only after the waitq is locked so we don't miss a wakeup. */
+	mutex_unlock(mtx);
+
+	errno_t rc = waitq_sleep_unsafe(&cv->wq, guard);
+
+	mutex_lock(mtx);
 	return rc;
 }
@@ -127,21 +126,12 @@
     uint32_t usec, int flags)
 {
-	errno_t rc;
-	ipl_t ipl;
-	bool blocked;
-
-	ipl = waitq_sleep_prepare(&cv->wq);
+	wait_guard_t guard = waitq_sleep_prepare(&cv->wq);
 
 	/* Unlock only after the waitq is locked so we don't miss a wakeup. */
 	spinlock_unlock(lock);
 
-	cv->wq.missed_wakeups = 0;	/* Enforce blocking. */
-	rc = waitq_sleep_timeout_unsafe(&cv->wq, usec, flags, &blocked);
-	assert(blocked || rc != EOK);
+	errno_t rc = waitq_sleep_timeout_unsafe(&cv->wq, usec, flags, guard);
 
-	waitq_sleep_finish(&cv->wq, blocked, ipl);
-	/* Lock only after releasing the waitq to avoid a possible deadlock. */
 	spinlock_lock(lock);
-
 	return rc;
 }
